Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.omg.PortableServer
Interface ServantLocatorOperations

All Superinterfaces:
  ServantManagerOperations

All Known Subinterfaces:
  ServantLocator

All Known Implementing Classes:
  _ServantLocatorStub, ServantLocatorPOA

public interface ServantLocatorOperations
extends ServantManagerOperations

When the POA has the NON_RETAIN policy it uses servant managers that are ServantLocators. Because the POA knows that the servant returned by this servant manager will be used only for a single request, it can supply extra information to the servant manager's operations and the servant manager's pair of operations may be able to cooperate to do something different than a ServantActivator. When the POA uses the ServantLocator interface, immediately after performing the operation invocation on the servant returned by preinvoke, the POA will invoke postinvoke on the servant manager, passing the ObjectId value and the Servant value as parameters (among others). This feature may be used to force every request for objects associated with a POA to be mediated by the servant manager.

Method Summary
`void` | `postinvoke(byte[] oid, POA adapter, String operation, Object the_cookie, Servant the_servant)` This operation is invoked whenener a servant completes a request.
`Servant` | `preinvoke(byte[] oid, POA adapter, String operation, CookieHolder the_cookie)` This operations is used to get a servant that will be used to process the request that caused preinvoke to be called.

Method Detail

### preinvoke

    public Servant preinvoke(byte[] oid,
                             POA adapter,
                             String operation,
                             CookieHolder the_cookie)
                      throws ForwardRequest

  This operations is used to get a servant that will be used to process the request that caused preinvoke to be called.

  Parameters:
    `oid` - the object id associated with object on which the request was made.
    `adapter` - the reference for POA in which the object is being activated.
    `operation` - the operation name.
    `the_cookie` - an opaque value that can be set by the servant manager to be used during postinvoke.
  Returns:
    Servant used to process incoming request.
  Throws:
    `ForwardRequest` - to indicate to the ORB that it is responsible for delivering the current request and subsequent requests to the object denoted in the forward_reference member of the exception.

### postinvoke

    public void postinvoke(byte[] oid,
                           POA adapter,
                           String operation,
                           Object the_cookie,
                           Servant the_servant)

  This operation is invoked whenener a servant completes a request.

  Parameters:
    `oid` - the object id ssociated with object on which the request was made.
    `adapter` - the reference for POA in which the object was active.
    `the_cookie` - an opaque value that contains the data set by preinvoke.
    `the_servant` - reference to the servant that is associated with the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.